var ironcurtain = {};

ironcurtain.loadingWidget = DIV(null, IMG({'src': '/static/images/loading.gif'}),
                                      SPAN({'class': 'previewLabel'}, 'Loading'));;

ironcurtain.columns = {'user': [['userName', 'User Name'],
                                ['password', 'Password'], 
                                ['displayName', 'Real Name'],
                                ['email', 'E-mail']],
                       'group': [['groupName', 'Group Name'], 
                                 ['displayName', 'Display Name']]};

ironcurtain.falsefields = {'user':  {'userName': '', 'password': '', 
                                     'displayName': '', 'email': ''},
                           'group': {'groupName': '', 'displayName': ''}}

ironcurtain.highlightObject = function(modelName)
{
    var el = document.getElementById('model_links');
    var children = el.getElementsByTagName('a');
    for (var i = 0; i < children.length; i++) {
        var child = children[i];
        if(child.getAttribute('id') == modelName + 'link') {
            child.style.color = '#000'; 
            child.style.fontWeight= '900'; 
        } else {
            child.style.color = '#999'; 
            child.style.fontWeight= ''; 
        }
    }
}

ironcurtain.display = function()
{
    replaceChildNodes('objects', null);
    var models = TBODY({'align': 'center'});
    models.appendChild(TD(null,A({'id':'list_user',
                                'href':"javascript:ironcurtain.retrieveObjects('user')",
                                'title': "List users"}, "Users")));
    models.appendChild(TD(null,A({'id':'list_group',
                                'href':"javascript:ironcurtain.retrieveObjects('group')",
                                'title': "List groups"}, "Groups")));
    
    replaceChildNodes('models', models);
}

ironcurtain.retrieveObjects = function(modelName)
{
    var d = loadJSONDoc('/uglist?modelName=' + modelName);
    ironcurtain.highlightObject(modelName);
    d.addCallback(ironcurtain.renderObjects);
}

ironcurtain.renderObjects = function(result)
{
    var data = { 'headers': result['headers'], 
                 'rows':result['objects'],
                 'hidden_columns':['id'],
                 'actions':{
                          'edit':{'function':'ironcurtain.retrieveObjectEdit','params':[result['modelName']]},
                          'remove':{'function':'ironcurtain.sendObjectDelete','params':[result['modelName']]}
                          }
             };


    var grid = Widget.grid.render(result['objects'], data);
    
    var s = DIV(null,
                ironcurtain.renderMenu(result['modelName']),
                grid
              );
    
    replaceChildNodes('objects', s);
    ironcurtain.menuSelect('browse')
}

ironcurtain.sendObjectDelete = function(modelName, id)
{
    if(!confirm('Are you sure you want to delete this ' + modelName + '?'))
        return;
    
    var d = loadJSONDoc('/ugdelete?modelName=' + modelName + '&mid=' + id);
    d.addCallback(ironcurtain.objectDeleteSent);
}

ironcurtain.objectDeleteSent = function(result)
{
    ironcurtain.retrieveObjects(result['modelName']);
}

ironcurtain.sendObjectUpdate = function(modelName, id)
{
    var postVars = ironcurtain.collectPostVars(document.myform);
    var d;
    if(id)
        d = loadJSONDoc('/ugupdate?' + postVars + '&modelName=' + modelName + '&mid=' + id);
    else
        d = loadJSONDoc('/ugupdate?' + postVars + '&modelName=' + modelName);
    
    d.addCallback(ironcurtain.renderObjects);
}

ironcurtain.renderMenu = function(model)
{
      return  DIV
          (
            null,
            TABLE({'class':'detail_menu','cellpadding':'0','cellspacing':'0','border':'0'},
                TBODY(null,
                      TR(null,
                        TD({'id':'cell_browse'},
                           A({'id':'link_browse',
                              'title': 'List all ' + model + 's',
                              'href':"javascript:ironcurtain.retrieveObjects('" + model + "')"},
                              'Browse')),
                        TD({'class':'spacing'}),
                        TD({'id':'cell_add','nowrap':'nowrap'},
                           A({'id':'link_add',
                              'title': 'Add new ' + model,
                              'href':"javascript:ironcurtain.retrieveObjectAdd('" + model + "')"},
                              'Add')),
                        TD({'class':'spacing','style':'width:300px'})
                      )
                )
             )
          );
}

ironcurtain.retrieveObjectEdit = function(modelName, id)
{
    var d = loadJSONDoc('/uginfo?modelName=' + modelName + '&mid=' + id);
    d.addCallback(ironcurtain.renderObjectEdit);
}

ironcurtain.renderObjectEdit = function(result)
{
    var modelName = result['modelName'];

    var cancelButton = ironcurtain.renderButton('btnCancel',
                                          ['Cancel', ,],
                                          'ironcurtain.retrieveObjects(' + "'" + modelName + "'" + ')',
                                          'Cancel'
                                          );
    
    var updateButton = ironcurtain.renderButton('btnUpdate',
                                    ['Update', ,],
                                    "ironcurtain.sendObjectUpdate('"+ modelName +"',"+ result['object']['id'] +")",
                                    'Update'
                                    );

    var formEdit = createDOM('DIV',null,
                            ironcurtain.renderMenu(modelName),
                            ironcurtain.renderObjectColumns(ironcurtain.columns[modelName], result['object']),
                            ironcurtain.makeJoinTable(modelName, result['object']['id']),
                            cancelButton,
                            updateButton
                          );


    replaceChildNodes('objects', formEdit);

}

ironcurtain.retrieveObjectAdd = function(modelName)
{
    ironcurtain.renderObjectAdd(modelName);
}

ironcurtain.renderObjectAdd = function(modelName)
{
    var cancelButton = ironcurtain.renderButton('btnCancel',
                                          ['Cancel', ,],
                                          'ironcurtain.retrieveObjects(' + "'" + modelName + "'" + ')',
                                          'Cancel'
                                          );

    var saveButton = ironcurtain.renderButton('btnSave',
                                    ['Save', ,],
                                    "ironcurtain.sendObjectUpdate('"+ modelName + "')",
                                    'Save'
                                    );

    var formSave = createDOM('DIV', null,
                            ironcurtain.renderMenu(modelName),
                            ironcurtain.renderObjectColumns(ironcurtain.columns[modelName], 
                                                            ironcurtain.falsefields[modelName]),
                            cancelButton,
                            saveButton
                          );

    replaceChildNodes('objects', formSave);
    ironcurtain.menuSelect('add');
}

ironcurtain.renderObjectColumns = function(labels, fields)
{
    var columns = TBODY(null);
    var columnValue;
    
    for(var i = 0; i < labels.length; i++) {  
        if(labels[i][0] == "email" || labels[i][0] == "displayName")   
            columnValue = ironcurtain.renderStringCol(labels[i][0], 
                                                      fields[labels[i][0]], false);
        else if(labels[i][0] == "password")
            columnValue = ironcurtain.renderStringCol(labels[i][0], "",  true, 16);
        else
            columnValue = ironcurtain.renderStringCol(labels[i][0], fields[labels[i][0]], false, 16);
        
        columns.appendChild(TR(null, TD({'valign':'top'},
                                        SPAN({'class':'previewLabel'}, labels[i][1])), 
                                        columnValue ));
    }
       
    return TABLE({'class':'detail_grid','cellpadding':'5'}, columns);
}

ironcurtain.renderStringCol = function(label, value, ispassword, maxlength)
{
    var fieldopts = {'class':'txtfield', 'type': ispassword ? 'password' : 'text', 
                     'name': label, 
                     'maxlength': (maxlength != null) ? maxlength : ''};

    if(value != null && value.length != null && value.length > 0)
        fieldopts['value'] = value;
    
    return TD(null, createDOM('INPUT', fieldopts));
}

ironcurtain.renderButton = function(btnId, label, action, title)
{
    var props = {'class':'buts',
                 'id':btnId,
                 'onclick':action 
                };
                
    if(Widget.exists(title)) 
        props['title'] = title;

    return createDOM('BUTTON', props, label[0], label[1], label[2]);
}

ironcurtain.menuSelect = function(menu_item)
{
    document.getElementById('cell_'+ menu_item).style.backgroundColor='#999';
    document.getElementById('link_'+ menu_item).style.color='#fff';
}

ironcurtain.collectPostVars = function(f)
{
    var postVars='';
    
    for(var i=0; i < f.elements.length; i++) {
        var t = f.elements[i].type;
        if(t.indexOf('text') > -1 || t.indexOf('password') > -1) {
            if(postVars!='')
                postVars+='&';
            postVars+= f.elements[i].name +'='+ encodeURIComponent(f.elements[i].value);
        }
    }
    
    return postVars;
}

ironcurtain.makeJoinTable = function(modelName, id)
{
    var joins = TBODY(null);
    var joinFullName = (modelName == "user") ? "Groups" : "Users";
    var joinName = (modelName == "user") ? "group" : "user";
    
    joins.appendChild(TR(null, TD({'valign': 'top'}, 
                                   A({'href': "javascript:ironcurtain.retrieveJoins('" + joinName + "', '" + id + "')"},
                                       IMG({'border':'0','style':'margin-right:5px','align':'bottom',
                                            'src': '/static/images/arrow_down.png', 
                                             'id': 'img_' + joinName})),
                                       SPAN({'class':'previewLabel'}, joinFullName))));
    joins.appendChild(TR({'valign': 'top'}, DIV({'id': 'join_table_' + joinName})));
    
    return joins;
}

ironcurtain.retrieveJoins = function(modelName, mid)
{
    var el = document.getElementById('img_' + modelName);
    
    if(el.getAttribute('src') == '/static/images/arrow_down.png') {
        var d = loadJSONDoc('/ugjoinlist?modelName=' + modelName + '&mid=' + mid);        
        d.addCallback(ironcurtain.renderJoins);
        el.setAttribute('src', '/static/images/arrow_right.png');
    } else {
        el.setAttribute('src', '/static/images/arrow_down.png');
        replaceChildNodes('join_table_' + modelName, '');
    }
}

ironcurtain.renderJoinElements = function(ele)
{
    return createDOM('OPTION', {'label': ele}, ele);
}

ironcurtain.removeSelectedJoins = function(joinName)
{
  var list = document.getElementById('select_remove_'+ joinName);
  Widget.select.removeSelectedOptions(list);
}

ironcurtain.addSelectedJoins = function(joinName)
{
  var src = document.getElementById('select_add_'+ joinName);
  var dest = document.getElementById('select_remove_'+ joinName);
  Widget.select.addSelectedOptionsFromSourceToDestination(src,dest);
}

ironcurtain.renderJoins = function(result) 
{
    var thisJoins = createDOM('SELECT',
                                {'id':'select_remove_'+ result['joinName'],
                                 'size':'10','style':'width:225px','multiple':'multiple'}, 
                                map(ironcurtain.renderJoinElements, result['thisJoins']));

    var allJoins = createDOM('SELECT',
                                {'id':'select_add_'+ result['joinName'],
                                 'size':'10','style':'width:225px','multiple':'multiple'}, 
                                map(ironcurtain.renderJoinElements, result['allJoins']));
                                

    var joinTable = TABLE(null, TBODY(null,
        TR(null, TD({'style':'border:none'},
                     SPAN({'class': 'previewLabel'}, 'Current ' + result['name'])),
                 TD({'style':'border:none'},
                     SPAN({'class': 'previewLabel'}, 'All ' + result['name']))),
        TR(null, TD({'style':'border:none'}, thisJoins),
                 TD({'style':'border:none'}, allJoins)),
        TR(null, TD({'style':'border:none'},
                    Widget.iconLabel.render('remove',
                                            'Remove Selected',
                                            'javascript:ironcurtain.removeSelectedJoins',
                                            [result['joinName']])),
                TD({'style':'border:none'},
                    Widget.iconLabel.render('add',
                                            'Add Selected',
                                            'javascript:ironcurtain.addSelectedJoins',
                                            [result['joinName']]))),
        TR(null, TD({'colspan': '2', 'align':'right'},
                    Widget.iconLabel.render('save',
                                            'Save',
                                            'javascript:ironcurtain.saveJoins',
                                            [result['joinName'], result['id']])))));

    replaceChildNodes('join_table_' + result['joinName'], joinTable);
}

ironcurtain.saveJoins = function(joinName, id)
{
  var params = 'joinName=' + joinName +'&mid=' + id;
  params +='&joins=' + Widget.select.getOptionValuesAsCSV(document.getElementById('select_remove_'+ joinName));

  var e = postJSONDoc('/ugjoinupdate', params);
  e.addCallback(ironcurtain.renderObjectEdit);
}

function postJSONDoc(url, postVars)
{
  var req = getXMLHttpRequest();
  req.open('POST', url, true);
  req.setRequestHeader('Content-type','application/x-www-form-urlencoded');
  var d = sendXMLHttpRequest(req, postVars);
  return d.addCallback(evalJSONRequest);
}
