"""Filter images by size"""

import Image
import os
import re
import cStringIO as StringIO
from constants import *

class ImageBlocker:
    """This plugin blocks images. """
    
    Args = []    
    
    Desc = "Blocks all the images"
    
    ApplyTime = AFTER_4KB
    
    def __init__ (self, params):    
        self.im = Image.open(os.path.join("..", "data", "images", "transparent.gif"))
                
    def act_on_req(self, cReq):
        return ACTION_FORWARD, ""
    
    def act_on_res(self, cRes):
        if not cRes.get_header("content-type") or not re.match("image\/*", cRes.get_header("content-type")):
            return ACTION_FORWARD, ""
    
        img = Image.open(StringIO.StringIO(cRes.body), 'r')        
        self.im.thumbnail(img.size)
        transimage = StringIO.StringIO()
        self.im.save(transimage,"GIF")
        transimage.seek(0)
        _data = transimage.read()
        cRes.replace_header("content-type", "image/gif")   
        cRes.replace_header("content-size", len(_data))            
        cRes.body = _data
        return ACTION_ANSWER, ""
