#!/usr/bin/env python
from socket import socket, AF_INET, SOCK_STREAM, SOL_SOCKET, SO_REUSEADDR
import asynchat, asyncore, os

from config import UI_HOST, UI_SOCKET_PORT
import PlugCore
import Auth
from Rpyc import SocketConnection, Async
from Rpyc.Utils.Serving import DEFAULT_PORT, threaded_server
from thread import start_new_thread
    
class ProxyListenHandler(asynchat.async_chat):
    rule_actions = {"add": PlugCore.add_or_update_rule, 
                    "delete": PlugCore.delete_rule}
    def __init__(self, conn):
        asynchat.async_chat.__init__(self, conn)   
        self.ibuffer = ""
        self.obuffer = ""
        self.set_terminator("69ce3b8b56970e62898b38c460cc2391")
        self.reading_headers = True
        
    def handle_connect(self):
        print "Baglandi , "
        
    def collect_incoming_data(self, data):
        """Buffer the data"""
        self.ibuffer += data
        
    def found_terminator(self):
        incoming = self.ibuffer;
        self.ibuffer = ""
          
        if incoming.startswith("rule "):
            incoming = incoming[5:]
            if incoming.startswith("add "):
                incoming = incoming[4:]
                action = "add"
            elif incoming.startswith("update "):
                incoming = incoming[7:]
                action = "add"
            elif incoming.startswith("delete "):
                incoming = incoming[7:]
                action = "delete"
            else:
                pass
            
            try:
                ruleId = int(incoming)
                self.rule_actions[action](ruleId)    
            except ValueError:
                pass
                       
        elif incoming.startswith("plugin "):
            incoming = incoming[7:]
            if incoming.startswith("args "):
                pluginName = incoming[4:]
                action = "args"
                self.send(str(PlugCore.get_args_plugin(pluginName)) + "\r\n")
            elif incoming.startswith("add "):
                incoming = incoming[4:]
                nend = incoming.find(" ")
                pluginName, fileData = incoming[:nend], incoming[nend + 1:]
                action = "add"
                plugFile = file(os.path.join("plugins", pluginName + ".py"), "w")
                plugFile.write(fileData)
                plugFile.close()
                PlugCore.add_plugin(pluginName)
            else:
                pass
        elif incoming.startswith("user "):
            incoming = incoming[5:]
            if incoming.startswith("login "):
                incoming = incoming[6:]
                ip_end = incoming.find(" ")
                ip, userId = incoming[:ip_end], incoming[ip_end + 1:]
                Auth.login_user_with_ip(ip, userId)
        else:
            print "Error: Action undefined"
   
    def handle_close(self):
        print "Baglanti kapandi"
        asynchat.async_chat.close(self)
     
class ProxyListener(asyncore.dispatcher):
    def __init__(self):
        asyncore.dispatcher.__init__(self)
        self.create_socket(AF_INET, SOCK_STREAM)
        self.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
        self.bind((UI_HOST, UI_SOCKET_PORT))
        print "Listening on", UI_HOST, UI_SOCKET_PORT
        start_new_thread(threaded_server, (DEFAULT_PORT,))
        self.listen(1024)
        
    def handle_accept(self):
        conn, addr = self.accept()
        ProxyListenHandler(conn)
        
    def handle_close(self):
        pass


