from urlparse import urlsplit
from urllib import urlopen
from httplib import HTTPConnection
from BeautifulSoup import BeautifulSoup
import re, sys, os

sys.path.append(os.path.join("..", "src"))
from thomas import Bayes, WebPageTokenizer

_pages = { "arts & humanities": ("http://www.artcyclopedia.com/",
                    "http://www.melonfarmers.co.uk/",
                    "http://www.worldwide-artbooks.com/wwb2_page.taf?_function=list&page_name=lead",
                    "http://www.artheals.org/start.html",
                    "http://www.guild.com/servlet/Guild/WelcomePage?refid=1466",
                    "http://www.we-make-money-not-art.com/",
                    "http://www.mediainspiration.com/",
                    "http://www.artschools.com/",
                    "http://www.culturalpolicy.org/",
                    "http://www.haberarts.com/myintro.htm",
                    "http://www.craftster.org/",
                    "http://www.artsig.com/go/main",
                    "http://www.deviantart.com/",
                    "http://www.metmuseum.org/",
                    "http://www.artjob.org/cgi-local/displayPage.pl?page=index.html",
                    "http://www.dia.org/",
                    "http://www.eserver.org/",
                    "http://www.sofaexpo.com/",
                    "http://www.artlex.com/",
                    "http://www.watsonswildlife.com/",
                    "http://www.puppetpub.com/",
                    "http://www.vsarts.org/",
           ),
           "business & economy": ("http://www.sprint.com/business/products/whySprint/index.html",
                    "http://www.smallbusinessforums.org/",
                    "http://www.corante.com/",
                    "http://finance.yahoo.com/",
                    "http://www.business-ethics.com/",
                    "http://www.analyzemycareer.com/",
                    "http://www2.sims.berkeley.edu/resources/infoecon/",
                    "http://www.coopamerica.org/",
                    "http://www.ncba.org/",
                    "http://www.methvenlaw.com/",
                    "http://www.xpdnc.com/",
                    "http://www.intelproplaw.com/",
                    "http://globalization.about.com/",
                    "http://www.transportweb.com/",
                    "http://www.tradezone.com/",
                    "http://www.etaxes.com/",
                    "http://www.bbb.org/",
                    "http://www.marketingprofs.com/intro.asp",
                  
                    ),
          "gambling": ("http://www.qfit.com/",
                    "http://www.satellitebingo.com/main.asp",
                    "http://www.sandiegoslots.com/",
                    "http://www.derbylane.com/",
                    "http://www.teachmecraps.com/",
                    "http://www.casinocitytimes.com/",
                    "http://www.venetian.com/",
                    "http://www.pokerbonuscodes.com/",
                    "http://www.harrahs.com/",
                    "http://www.vegasinsider.com/",
                    "http://www.instantpokerchips.com/",
                    "http://www.fresco-shinjuku.com/",
                    "http://www.allhorseracing.com/",
                    "http://www.mylottocorner.com/",
		    "http://www.betfair.com/",
		    "http://www.betandwin.com/",
                    ),
          "computers & internet": ("http://www.comdex.com/",
                    "http://www.ioccc.org/",
                    "http://slashdot.org/",
                    "http://citeseer.ist.psu.edu/",
                    "http://cf.hum.uva.nl/mmm/",
                    "http://www.digitalartsource.com/index2.shtml",
                    "http://compnetworking.about.com/",
                    "http://www.graphics.com/",
                    "http://www.computerforensicsworld.com/",
                    "http://www.wolfson.ox.ac.uk/~floridi/ie.htm",
                    "http://www.dice.com/",
                    "http://www.stardock.com/",
                    "http://desktoppublishing.com/",
                    "http://www.webopedia.com/",
                    "http://pespmc1.vub.ac.be/",
                    "http://www.wotsit.org/",
                    "http://dotmac.info/",
                    "http://www.emailman.com/",
                    "http://www.itmweb.com/",
                    "http://www.bitpipe.com/",
                    "http://www.jokewallpaper.com/",
                    "http://www.old-computers.com/news/default.asp",
                    "http://www.spec.org/",
                    "http://www.top500.org/",
                    "http://www.unicode.org/",
                    "http://www.anandtech.com/",
                    "http://www.biodiv.org/default.shtml",
                    "http://www.securityfocus.com/",
                    "http://www.programmersheaven.com/",
                    "http://www.osnews.com/",
                    "http://www.streamingmediaworld.com/",
                    "http://www.handhelds.org/geeklog/index.php",
                    "http://www.pcworld.com/",
                    "http://www.webreference.com/",
                    "http://www.informit.com/index.asp?rl=1",
                    "http://www.cyberedge.com/",
                    "http://www.apcug.net/",
                    "http://www.sans.org/",
                    "http://www.rfglobalnet.com/content/homepage/default.asp?VNETCOOKIE=NO",
                    "http://www.experts-exchange.com/",
                    ),
           "games": ("http://www.gametrailers.com/",
                    "http://www.fileplanet.com/",
                    "http://www.gamasutra.com/",
                    "http://www.gamasutra.com/",
                    "http://www.gamedev.net/",
                    "http://www.gamefaqs.com/",
                    "http://www.3dgamers.com/",
                    "http://www.gamepro.com/",
                    "http://www.gamewinners.com/",
                    "http://www.gamers.com/",
                    "http://www.twingalaxies.com/",
                    "http://videogames.yahoo.com/",
                    "http://www.megagames.com/",
                    "http://www.happypuppy.com/",
                    "http://www.gamespot.com/",
                    ),
           "education": ("http://www.kumon.com/?ovmkt=B4RS42I76GDIKE2J7DHUKGQHC0&OVRAW=%7CK-12%20Education%7Ceducation&OVKEY=education&OVMTC=standard",
                    "http://www.nytimes.com/college/",
                    "http://www.uwex.edu/disted/home.html",
                    "http://www.degrees-online.us/",
                    "http://www.nwrel.org/scpd/sirs/1/topsyn1.html",
                    "http://www.tea.state.tx.us/",
                    "http://www.colleges.com/",
                    "http://www.ed.gov/offices/OVAE/AdultEd/OCE/index.html",
                    "http://www.nexuseq.com/",
                    "http://www.top-colleges.com/v/business.html?source=ov-tc-bus",
                    "http://www.ed.gov/about/offices/list/ovae/index.html",
                    "http://ali.apple.com/",
                    "http://www.nabe.org/",
                    "http://www.sourceaid.com/",
                    "http://www.odysseyofthemind.com/",
                    "http://www.iste.org/",
                    "http://www.socsci.kun.nl/ped/whp/histeduc/",
                    "http://www.fafsa.ed.gov/",
                    "http://www.tolerance.org/",
                    "http://www.childfun.com/",
                    "http://www.wrightslaw.com/",
                    "http://www.edpolicy.org/",
                    "http://www.ascd.org/portal/site/ascd/index.jsp/",
                    "http://www.edweek.org/ew/index.html",
                    "http://www.literacyconnections.com/",
                    "http://www.bced.gov.bc.ca/legislation/schoollaw/",
                    "http://www.readingonline.org/",
                    "http://www.schoolspring.com/",
                    "http://www.kn.pacbell.com/wired/bluewebn/",
                    "http://www.infed.org/",
                    "http://www.teachers.net/",
                    "http://www.collegeboard.com/splash",
                    "http://www.middleweb.com/",
                    ),
           "entertainment": ("http://www.toonopedia.com/",
                    "http://www.goonland.com/",
                    "http://www.poobala.com/crossoverlist.html",
                    "http://www.cannesguide.com/",
                    "http://www.themoviespoiler.com/",
                    "http://www.wilwheaton.net/",
                    "http://www.synchronicityarkive.com/",
                    "http://www.bluemountain.com/",
                    "http://www.globalbeauties.com/",
                    "http://www.gizmodo.com/",
                    "http://www.borowitzreport.com/",
                    "http://www.chatlist.com/",
                    "http://www.bookwire.com/",
                    "http://www.pgfusa.com/",
                    "http://www.sixflags.com/",
                    "http://allmagic.com/allmagicguide/",
                    "http://www.epicurious.com/",
                    "http://www.thefanlistings.org/",
                    "http://www.merging.com/",
                    "http://www.showbizjobs.com/",
                    "http://www.thesuperficial.com/",
                    "http://www.thespot.com/",
                    "http://www.metacritic.com/",
                    "http://www.lipsum.com/",
                    ),
           "government": ("http://www.fedworld.gov/",
                    "http://www.pollingreport.com/",
                    "http://www.army.com/",
                    "http://www.lawyers.com/",
                    "http://www.worldstatesmen.org/",
                    "http://www.odci.gov/cia/publications/chiefs/",
                    "http://www.rulers.org/",
                    "http://www.un.org/",
                    "http://www.interpol.int/",
                    "http://www.embassy.org/",
                    "http://www.gpoaccess.gov/databases.html",
                    "http://www.usoge.gov/index.html",
                    "http://asem.inter.net.th/",
                    "http://www.opendemocracy.net/home/index.jsp",
                    "http://www.munisource.org/",
                    "http://www.gksoft.com/govt/",
                    "http://www.statistics.gov.uk/",
                    "http://www.world-psi.org/",
                    "http://www.un.org/News/",
                    "http://www.urbdocs.com/index.asp?ws=WS_ICUD&as=index.asp&token=2576CB21E07CD61278DE12FDE757C0B1",
                    ),
           "health": ("http://www.coldoneinc.com/shoulderwrap.html?OVRAW=%7CDiseases%20and%20Conditions%7Crotator%20cuff&OVKEY=rotator%20cuff&OVMTC=standard",
                    "http://www.mossresourcenet.org/",
                    "http://www.simplestepsdental.com/SS/ihtSS/r.WSIHW000/st.31819/t.31819/pr.3.html",
                    "http://www.pbs.org/witheyesopen/",
                    "http://www.saleawaysavings.com/",
                    "http://www.ehfg.org/",
                    "http://www.kidshealth.org/",
                    "http://www.healthboards.com/",
                    "http://www.noah-health.org/en/alternative/",
                    "http://www.healthgrades.com/",
                    "http://www.sarswatch.org/",
                    "http://www.casemix.org/",
                    "http://www.mayoclinic.com/",
                    "http://www.justmove.org/home.cfm",
                    "http://www.healthy.net/scr/MainLinks.asp?Id=170",
                    "http://www.scorecard.org/",
                    "http://www.trauma-pages.com/",
                    "http://education.indiana.edu/cas/adol/adol.html",
                    "http://www.medscape.com/home",
                    "http://www.menshealthnetwork.org/",
                    "http://www.who.int/en/",
                    "http://www.hhs.gov/ocr/hipaa/",
                    "http://www.nih.gov/",
                    "http://www.breastbiopsy.com/",
                    "http://www.pharmweb.net/",
                    "http://www.healthypet.com/",
                    "http://www.ific.org/",
                    "http://www.nurseweek.com/",
                    "http://www.birthcenters.org/",
                    "http://www.mentalhealth.com/",
                    "https://www.tripprep.com/scripts/main/default.asp",
                    "http://www.sexualhealth.com/",
                    "http://www.teenshealth.org/teen/",
                    ),
          "news & media": ("http://www.thesmokinggun.com/",
                    "http://www.killradio.org/",
                    "http://www.cyberjournalist.net/",
                    "http://www.doaj.org/",
                    "http://www.icra.org/",
                    "http://news.yahoo.com/",
                    "http://www.msnbc.msn.com/id/3032542/site/newsweek/",
                    "http://www.tv-forums.com/",
                    "http://www.worlddab.org/",
                    "http://www.nytimes.com/",
                    "http://www.time.com/time/",
                    "http://abcnews.go.com/?CMP=yahoo_general",
                    "http://www.inman.com/default.aspx",
                    "http://www.electionworld.org/",
                    "http://www.oneworld.net/",
                    "http://outside.away.com/news/index.html",
                    "http://www.sciencenewsforkids.org/",
                    "http://www.nytimes.com/pages/books/",
                    "http://www.cnn.com/LAW/",
                    "http://www.abilityinfo.com/ticker.html",
                    "http://www.crimenews2000.com/",
                    "http://www.cnet.com/",
                    "http://www.forteantimes.com/",
                    "http://www.weather.com/",
                    "http://travel.discovery.com/",
                    "http://www.fhwa.dot.gov/trafficinfo/",
                    "http://www.kuro5hin.org/",
                    "http://www.nerve.com/",
                    "http://www.sciencedaily.com/",
                    "http://www.enn.com/",
                    ),
        "recreation & sports": ("http://www.fueleconomy.gov/",
                    "http://www.theautochannel.com/",
                    "http://www.121s.com/",
                    "http://www.sportscolumn.com/",
                    "http://fanhome.scout.com/",
                    "http://sports.espn.go.com/chat/sportsnation/index",
                    "http://www.smallstep.gov/",
                    "http://www.discountdance.com/index.php",
                    "http://www.foodsubs.com/",
                    "http://www.4x4books.com/",
                    "http://autos.yahoo.com/",
                    "http://www.dollywood.com/",
                    "http://www.credit-land.com/index.php?link=8024",
                    "http://www.timesharesonly.com/",
                    "http://www.infohub.com/",
                    "http://www.msu.edu/course/prr/840/econimpact/",
                    "http://www.amtrakguestrewards.com/index.cfm?category=earn&loc=b2g1winter06.html&WT.mc_t=ACSPRFY06&WT.mc_n=YSTRAV&WT.mc_r=30",
                    "http://www.tonydean.com/",
                    "http://www.fieldsauto.com/",
                    "http://www.doghause.com/",
                    "http://www.backpacker.com/",
                    "http://www.motogp.com/en/motogp/index.htm",
                    "http://www.socceramerica.com/",
                    "http://hobbies.expertvillage.com/",
                    ),
        "reference": ("http://www.whowhere.com/",
                    "http://thesaurus.reference.com/",
                    "http://www.britannica.com/",
                    "http://www.timeanddate.com/",
                    "http://ircalc.usps.gov/",
                    "http://www.cedar.buffalo.edu/adserv.html",
                    "http://www.calendarzone.com/",
                    "http://www.encyclopedia.com/",
                    "http://www.wordsmyth.net/",
                    "http://www.m-w.com/",
                    "http://www.flickr.com/groups/librariesandlibrarians/pool/",
                    "http://www.infospace.com/",
                    "http://tycho.usno.navy.mil/",
                    "http://www.awesomelibrary.org/",
                    "http://searchenginewatch.com/",
                   ),
        "regional": ("http://plasma.nationalgeographic.com/mapmachine/",
                    "http://www.cities.com/",
                    "http://www.calle.com/world/",
                    "http://www.indo.com/distance/",
                    "http://geography.about.com/",
                    "http://www.cia.gov/cia/publications/factbook/",
                    ),                 
        "science": ("http://biotech.icmb.utexas.edu/",
                    "http://www.chemweb.com/",
                    "http://www.emc.maricopa.edu/faculty/farabee/BIOBK/BioBookTOC.html",
                    "http://www.badastronomy.com/",
                    "http://www.alife.org/",
                    "http://www.mnsu.edu/emuseum/index.shtml",
                    "http://animaldiversity.ummz.umich.edu/site/index.html",
                    "http://www.agriculture.com/",
                    "http://ridge.oce.orst.edu/oldhome.html",
                    "http://www.usgs.gov/",
                    "http://www.tarorigin.com/",
                    "http://manufacturing.stanford.edu/",
                    "http://www.eia.doe.gov/",
                    "http://www.ecology.com/",
                    "http://visibleearth.nasa.gov/",
                    "http://www.multiagent.com/",
                    "http://cogprints.org/",
                    "http://www.nasa.gov/externalflash/nasa_gen/",
                    "http://www.windows.ucar.edu/",
                    "http://www.guidetopsychology.com/",
                    "http://www.physics2005.org/",
                    "http://www.oceanexplorer.noaa.gov/",
                    "http://www.zyvex.com/nano/",
                    "http://www.nws.noaa.gov/",
                    "http://mathworld.wolfram.com/",
                    "http://www.pubmedcentral.nih.gov/",
                    "http://www.itlocation.com/",
                    "http://ga.water.usgs.gov/edu/",
                 ),                 
        "social science": ("http://www.abilityinfo.com/",
                    "http://www.sou.edu/English/IDTC/Swirl/swirl.htm",
                    "http://www.design.upenn.edu/arch/news/Human_Settlements/home.html",
                    "http://www.marshallmcluhan.com/",
                    "http://www.americassuburb.com/",
                    "http://www.econlit.org/",
                    "http://lcweb2.loc.gov/frd/cs/",
                    "http://www.nmnh.si.edu/naa/",
                    "http://jurist.law.pitt.edu/",
                    "http://www.library.uiuc.edu/edx/",
                    "http://www.colorado.edu/English/ENGL2012Klages/queertheory.html",
                    "http://www.annualreviews.org/",
                    "http://www.esrc.ac.uk/ESRCInfoCentre/index.aspx",
                    "http://www.historyguide.org/",
                    "http://www.geron.org/",
                    "http://www.indo.com/distance/",
                    "http://www.familysearch.org/",
                    "http://vos.ucsb.edu/browse.asp?id=2711",
                    "http://www.longbets.org/",
                    "http://www.ss.ucalgary.ca/ces/",
                    "http://wssa.asu.edu/",
                    "http://www.utm.edu/research/iep/",
                    "http://www.hsrc.ac.za/",
                    "http://www.migrationinformation.org/",
                    "http://www.ethnologue.com/",
                    "http://lcweb2.loc.gov/ammem/awhhtml/",
                    "http://www.sociosite.net/index.php",
                    "http://www.citistates.com/",
                    "http://www.ac.wwu.edu/~stephan/timeline.html",
                    "http://www.socialworker.com/home/index.php",
                    "http://webapp.icpsr.umich.edu/GSS/",
                    "http://math.ucsd.edu/~weinrich/linx.html",
                    "http://www.k-web.org/",
                    "http://ec.europa.eu/comm/agriculture/rur/index_en.htm",
                    "http://www.cfr.ncsu.edu/rrs/",
                   ),                 
        "society & culture": ("http://eawc.evansville.edu/",
                    "http://www.thefamilycorner.com/",
                    "http://www.airlinemeals.net/",
                    "http://www.theholidayzone.com/",
                    "http://www.sysadminday.com/",
                    "http://www.foodreference.com/",
                    "http://www.kaboose.com/",
                    "http://www.enature.com/home/",
                    "http://www.ipl.org/div/kidspace/cquest/",
                    "http://www.crimelibrary.com/",
                    "http://www.sexuality.org/",
                    "http://www.thearda.com/",
                    "http://www.socio.demon.co.uk/Cyborgasms.html",
                    "http://www.itstime.com/rainbow.htm",
                    "http://www.lost-love-registry.com/",
                    "http://www.biography.com/",
                    "http://www.pantheon.org/",
                    "http://www.globalissues.org/",
                    ),                 
           "porn": ("http://us.adultshop.com", 
                    "http://www.3pic.com", 
                    "http://www.bigvids.com", 
                    "http://www.deluxearchive.com",
                    "http://www.freebigmovies.com", 
                    "http://www.freeporndivxs.com", 
                    "http://www.fuckingfreemovies.com", 
                    "http://www.gimmeteens.com", 
                    "http://www.hoes.com", 
                    "http://www.how-to-fuck.info", 
                    "http://www.ilove-movies.com", 
                    "http://www.jizzhut.com", 
                    "http://www.karasamateurs.com", 
                    "http://www.kazaaporn.com",
                    "http://www.p-bot.com", 
                    "http://www.musclemenxxx.com", 
                    "http://www.pornovault.net",
                     "http://www.sexmoviesex.com", 
                    "http://www.smokinmovies.com",
                     "http://www.soakedmovies.com", 
                    "http://www.stileproject.com",
                     "http://www.teengirlsrevenge.com", 
                    "http://www.uporn.net", 
                    "http://www.vidsvidsvids.com", 
                    "http://www.youho.com")
         }

def _full_path(path, query, fragment):
    fpath = path
    if(query != ""):
        fpath += "?" + query
    if(fragment != ""):
        fpath += "#" + fragment
    return fpath

def _parse_page(page):
    return BeautifulSoup(urlopen(page).read())

def check_for_keywords(htmlparser):
    for tag in htmlparser.fetch("meta"):
        try: nameVal = tag.get("name").lower()
        except: nameVal = ""
           
        try: equivVal = tag.get("http-equiv").lower()
        except: equivVal = ""

        if "keyword" in nameVal or "keyword" in equivVal:
            keywords = tag.get("content")
            if keywords == None: continue
            return True
        
    return False
    
def save_all():
    result = {}
    for item in _pages.iteritems():
        for page in item[1]:
            prsr = _parse_page(page)
            if check_for_keywords(prsr):
                print "Saving", page
                try: result[item[0]] = urlopen(page).read()
                except: continue
    import cPickle
    cPickle.dump(result, file("pagecache.pickle", "w"))
    return result

def train_all_from_cache():
    import cPickle
    guesser = Bayes(WebPageTokenizer())    
    result = cPickle.load(file("pagecache.pickle"))
    for item in result.iteritems():
        for prsr in item[1]:
            try: guesser.train(item[0], prsr)
            except: continue
    return guesser

def train_one(guesser, tag, page):
    try: guesser.train(tag, _parse_page(page))
    except: pass
    return guesser
    
def train_all():
    guesser = Bayes(WebPageTokenizer())
    wokeywords = 0
    count = 0
    pages_without_keywords = []
    for item in _pages.iteritems():
        for page in item[1]:
            count += 1
            print "Fetching", page, "for", item[0], count
	    try:
                prsr = _parse_page(page)
                if check_for_keywords(prsr):
                    guesser.train(item[0], prsr)
                else:
                    print "Page " + page + " has no keywords; skipping"
                    pages_without_keywords.append(page)
                    wokeywords += 1
            except: continue
    
    print "%s pages did not have keywords" % (wokeywords)
    for page in pages_without_keywords:
        print page
    return guesser

def guess(guesser, page):
    return guesser.guess(_parse_page(page))
